/* icode.h
 * definition of class icode
 */

#ifndef ICODE_H
#define ICODE_H


#include "aint_consts.h"
#include "aint_types.h"
#include "reg.h"
class icode {
public:
  icode() { 
    args[RA] = args[RB] = args[RC] = args[MaxArgs] = ZERO_REGISTER;
    dest = MaxArgs;
  }

  // func takes IACTION_ARGS and returns icode_ptr - see aint_types.h
    icode_ptr action(inflight_inst_ptr _ifi, icode_ptr _picode, 
		 path_ptr _ppath, thread_ptr _pthread)
    {return (*func)(_ifi, _picode, _ppath, _pthread);}

  icode_ptr (*func)(inflight_inst_ptr ifi, icode_ptr picode, path_ptr ppath, thread_ptr _pthread);
  icode_ptr (*memop_func)(inflight_inst_ptr ifi, icode_ptr picode, path_ptr ppath, thread_ptr _pthread);

  icode_ptr next;
  Logical_RegNum args[MaxArgs+1];
  Arg dest;
  long immed;           // the immed/disp/func/hint field */
  aint_addr_t addr;            // text address of this instr */
  icode_ptr target;        // target icode of a branch/bsr instruction */
  unsigned short literal;    // literal field in operate instr: if hi=0 */
  unsigned short cycles;
  aint_instr_t instr;               /* undecoded instruction */
  unsigned int iflags;       /* tells what kind of instruction */
  unsigned int opnum;       /* opnum (operation index) for instruction */
  size_t size;        /* of load/store data item */

#define USE_FAST_FUNC
#undef USE_FAST_FUNC

#ifndef USE_FAST_FUNC
  /*
   * For dirk speedups
   * op_function is function within an operation group.
   */
  unsigned short op_form; /* immediate or register form */
#endif

};


#endif
