/* symtab.C
 * implements the read_hdrs and find_proc_addr functions
 */

#include <iostream.h>
#include <filehdr.h>
#include <aouthdr.h>
#include <scnhdr.h>
#include <syms.h>
#include <ldfcn.h>
#include <string.h>

#include "aint.h"
#include "globals.h"




/*
 * Look up the load-time address of symbol_name in objfile
 */
unsigned long
find_proc_addr(const char *Objname, const char *symbol_name)
{
  static LDFILE *ldptr = NULL;
  int symindex;
  char *_Objname = strdup(Objname);
  
  if ( ldptr == NULL ) {
    // ldopen takes a char *; Objname is a const char *
    ldptr = ldopen(_Objname, NULL);
    if ( ldptr == NULL ) {
      perror("ldopen");
      return 0;
    }
    delete _Objname;
  }

  if ( ldtbseek(ldptr) != SUCCESS ) {
    perror("ldtbseek");
    return 0;
  }
  
  for (symindex = 0; ; symindex++ ) {
    int status;
    SYMR duh_symbol;
    pSYMR symbol = &duh_symbol;
    status = ldtbread(ldptr, symindex, symbol);

    if ( status != SUCCESS ) {
      return( (unsigned long)NULL );
    } else {
      char *name = ldgetname(ldptr, symbol); 
      if ( strcmp(name, symbol_name) == 0 ) {
	if ( (symbol -> sc == scText) && (symbol -> st == stProc) ) {
#if DEBUG
	  Aint_output << "*** Found sim_user function, addr = " << symbol->value << endl;
#endif
	   return ((unsigned long) symbol->value);
	} 
      }
    }
  }
}
