/* FEtest1.c
 * a simple 2-thread program that increments a single shared variable many times
 * using load_s and store_s operations
 */

#include <stdio.h>

#include <aint_pthread.h>
#include <op_s.h>

volatile unsigned long SharedSum;
void * thread_run_p(void *);
struct threadinfo_s {
    int N;
    int id;
};

void * do_add(void *ti);

int main(int argc, char **argv)
{
    int i, N;
    void *dummy;
    PTHREAD_T thread_1;

    struct threadinfo_s t0, t1;

    if (argc != 2) {
	puts("\nEnter number of iterations for addition loop: ");
	scanf("%d", &N);
    } else {
	sscanf(argv[1], "%d", &N);
    }

    /* Initialize the threadinfo structs */
    t0.N = N;
    t0.id = 0;

    t1.N = N;
    t1.id = 1;

    /* Get SharedSum in a known (full) state */
    SharedSum = 0;

    PTHREAD_CREATE(&thread_1, NULL, thread_run_p, (void *) &t1);

    printf("main thread calling do_add...\n"); fflush(stdout);
    do_add((void *) &t0);
    printf("main thread done callig do_add...\n"); fflush(stdout);

    PTHREAD_JOIN(thread_1, &dummy);

    printf ("\nSharedSum = %ld\n", SharedSum);
}

void * thread_run_p(void * ti)
{
  do_add(ti);

  PTHREAD_EXIT((void *) NULL);
}

void * do_add(void * ti)
{
  unsigned long i;
  volatile unsigned long x;
  unsigned long PrivateSum=0;
  struct threadinfo_s *t = (struct threadinfo_s *) ti;

  for (i=0; i<t->N; i++) {
      load_s(x, &SharedSum);
      printf("\n%d: Obtained copy of shared sum: %d\n", t->id, x); fflush(stdout);
      x += i;
      PrivateSum += i;
      printf("\n%d: Storing SharedSum i=%d, Sum=%d\n", t->id, i, x); fflush(stdout);
      store_s(x, &SharedSum);
  }

  printf("\n%d:PrivateSum = %d\n", t->id, PrivateSum);
  fflush(stdout);

  return (void *) NULL;
}
