#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

#define N 256

#define SMALL 1.0e-12

int main()
{
  int n, row, col;
  double A[N][N], I[N][N], x[N], b[N], b1[N];


  n = N;
  /* Fill in the matrix first */
  srand48((long)time(0));
  srandom((int)time(0));

  for (row=0; row<n; row++) for (col=0; col<n; col++) {
    A[row][col] = drand48()*random();
    I[row][col] = 0;
  }

  for (row=0; row<n; row++) {
    b[row] = drand48()*random();
    I[row][row] = 0;
  }

  /* Gauss Elim */
  for (row = 0; row < N; row++) {
    int newrow;
    if ( fabs(A[row][row]) <= SMALL ) {
      /* Find a good row */
      for (newrow=row+1; newrow<N; newrow++) {
	if (fabs(A[newrow][row]) > SMALL) break;
      }
      if (newrow > N) {
	printf("Matrix is singular or ill-conditioned\n");
	exit(1);
      }
      for (col=0; col<N; col++) {
	double temp;
	temp = A[row][col]; 
	A[row][col] = A[newrow][col]; 
	A[newrow][col] = temp;
	temp = I[row][col];
	I[row][col] = I[newrow][col];
	I[newrow][col] = temp;
      }
    }
    
    /* Divide by pivot */
    for (col=0; col<N; col++) {
      double pivot = A[row][row];
      A[row][col] /= pivot;
      I[row][col] /= pivot;
    }

    /* Make the column zero */
    for (newrow = 0; newrow<N; newrow++) {
      double factor;
      factor = A[newrow][row];
      if (newrow == row) break;
      for (col = row; col<N; col++) {
	A[newrow][col] -= A[row][col]*factor;
      }
    }

  }

  for (row=0; row<N; row++) {
    x[row] = 0.0;
    for (col = 0; col < N; col++) x[row] += I[row][col]*b[col];
  }    

  /* We now have the solution. Check it and find error vector */
  for (row = 0; row < N; row ++) {
    b1[row] = 0.0;
    for (col = 0; col < N; col++) b1[row] += A[row][col]*x[col];
    printf("%g\n", fabs(b[row] - b1[row]));
  }
}
