     /*

       * OSF/1:            cc -o twait -std1 -g -threads twait.c

       */

     #include <pthread.h>

     #include <stdio.h>

     #include <stdlib.h>

     #include <errno.h>


     #define MAX_TICKS 30

     #define THRID(x)   pthread_getunique_np(x)

     pthread_mutex_t     exit_lock;

     pthread_cond_t       exit_cv;

     int                          exit_requested;


     /*

       * Start routine for timer thread.

       */

     void

     do_tick(pthread_addr_t argP)

     {

            pthread_t              me = pthread_self();

            struct timespec   abstime, delta = {1,0};

            int                        status, ticks = 0;


            printf("%d: timer thread starting up, argP=0x%p0,

                                                                                THRID(&me), argP);

            while (ticks++ < MAX_TICKS) {

                   status = pthread_get_expiration_np(&delta, &abstime);


                   status = pthread_mutex_lock(&exit_lock);

                   if (exit_requested) {

                          printf("%d: exiting by request...0, THRID(&me));

                          status = pthread_mutex_unlock(&exit_lock);

                          pthread_exit(argP);

                   }

                   printf("%d: wait for next tick0, THRID(&me));


                   status = pthread_cond_timedwait(&exit_cv,

                                                                           &exit_lock,

                                                                           &abstime);

                   status = pthread_mutex_unlock(&exit_lock);

                   printf("%d: TICK #%d0, THRID(&me), ticks);

            }


            printf("%d: exiting after #%d ticks0, THRID(&me), ticks);

            pthread_exit(argP);

     }


     main()

     {

            pthread_t            me = pthread_self(), timer_thread;

            pthread_addr_t   ret_argP = NULL;

            int                      status;

            errno = 0;

            printf("%d: main thread starting up0, THRID(&me));

            if (errno != 0) printf("errno 1 = %d0,errno);

            status = pthread_mutex_init(&exit_lock,

                            pthread_mutexattr_default);

            printf("%d: exit lock initialized0, THRID(&me));

            if (errno != 0) printf("errno 2 = %d0,errno);


            status = pthread_mutex_lock(&exit_lock);

            printf("%d: exit lock obtained0, THRID(&me));

            if (errno != 0) printf("errno 3 = %d0,errno);

            exit_requested = FALSE;


            status = pthread_cond_init(&exit_cv,

                            pthread_condattr_default);

            printf("%d: exit cv initialized0, THRID(&me));

            if (errno != 0) printf("errno 4 = %d0,errno);


            status = pthread_create(&timer_thread,

                                                      pthread_attr_default,

                                                      (pthread_startroutine_t)do_tick,

                                                      (pthread_addr_t) NULL);


            printf("%d: timer_thread %d created0, THRID(&me),

                            THRID(&timer_thread));

            if (errno != 0) printf("errno 5 = %d0,errno);


            status = pthread_mutex_unlock(&exit_lock);

            printf("%d: exit lock released0, THRID(&me));

            if (errno != 0) printf("errno 6 = %d0,errno);


            status = pthread_join(timer_thread,

                            (pthread_addr_t *) &ret_argP);


            printf("%d: joined with timer_thread %d0,

                                     THRID(&me),THRID(&timer_thread));

            if (errno != 0) printf("errno 7 = %d0,errno);

     }

